#!/bin/bash
#
# VFile Script 0 to apply update for VDisk
#
echo Installing Virtual Disk, Please Wait...

if [ -e /uxlog/.pending ] ; then
	echo 'Update already pending....' >> /uxlog/output.log
    exit
fi

REBOOT=0
DATE="`date`"
UXTYPE='RemoteUX'

# parse argument list
while [ $# -ge 1 ]; do
case $1 in
    -r) REBOOT=1; shift;;
    *)  break;;
esac
shift
done

export PATH=$PATH:.

if [ ! -e MBR.DAT ] ; then
	mv _MBR.DAT MBR.DAT
fi

FSTYPE=`grep /boot /proc/mounts | awk '{ print $3 }'`

if [ -z $FSTYPE ] ; then
	FSTYPE=`grep /dev/root /proc/mounts | awk '{ print $3 }'`
fi

if [ ! -e /boot/uxlog ] ; then
	if [ ! -L /uxlog ] ; then
		if [ -d /uxlog ] ; then
			mv /uxlog /boot
		fi
		if [ -f /uxlog ] ; then
			mv /uxlog /uxlog.uxmoved
		fi
		if [ ! -d /boot/uxlog ] ; then
			mkdir /boot/uxlog
		fi
	else
		mv /uxlog /uxlog.uxmoved
		mkdir /boot/uxlog
	fi

	ln -s /boot/uxlog /uxlog

else
	if [ -L /boot/uxlog ] ; then
		mv /boot/uxlog /boot/uxlog.uxmoved
		mkdir /boot/uxlog
	fi
	if [ ! -L /uxlog ] ; then
		if [ -d /uxlog ] ; then
			mv /uxlog /uxlog.uxmoved
		fi
		if [ -f /uxlog ] ; then
			mv /uxlog /uxlog.uxmoved
		fi
		if [ ! -d /boot/uxlog ] ; then
			mv /boot/uxlog /boot/uxlog.uxmoved
			mkdir /boot/uxlog
		fi
		ln -s /boot/uxlog /uxlog
	fi
fi

echo > /uxlog/output.log

if [ ! $FSTYPE = 'ext2' -a ! $FSTYPE = 'ext3' ] ; then
	echo "$DATE, Schedule Update=$UXTYPE , New=, Status=Failed, ReturnCode=$RET, Unsupported filesystem: $FSTYPE" >> /uxlog/ux.log
fi


cp ../pcdos.img disk144.VFD
cp ../pqvdisk.cmd .
./vfile call mk144.cmd >> /uxlog/output.log 2>&1 
if [ -e VDisk.vfd ] ; then
	rm -f VDisk.vfd
fi

#vfile call mkvdisk.cmd
./vfile call pqvdisk.cmd >> /uxlog/output.log 2>&1 

# boot floppy image must be called pqvf.vfd for vdinst
mv disk144.VFD PQVF.VFD

vdinstlx -install VDisk.vfd -Dbg -nrb >> /uxlog/output.log 2>&1 

RET=$?
if [ $RET -eq '1' ] ; then
	STAT=Success
	touch /uxlog/.pending
	chmod 755 uxpkg
	if [ ! -e /etc/init.d/uxpkg ] ; then
		cp uxpkg /etc/init.d/uxpkg
		ln -s /etc/init.d/uxpkg /etc/rc.d/rc0.d/S00uxpkg
		ln -s /etc/init.d/uxpkg /etc/rc.d/rc6.d/S00uxpkg
	fi
else
	STAT=Failed
#       opt is set to a dummy argument so that it does not force reboot
#       on failure.
	opt='Failed'
fi

echo "$DATE, Schedule Update=$UXTYPE , New=, Status=$STAT, ReturnCode=$RET" >> /uxlog/ux.log

# clean up now
rm -rf ../SGUIDE

if [ $REBOOT -eq 1 ] ; then
    #If successful, reboot the system
    if [ $STAT = 'Success' ] ; then
        echo 'Rebooting Server.' >> /uxlog/output.log
	    shutdown -r now
    fi
fi
